#include <bits/stdc++.h>

using namespace std;
int N,X,K;
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> N >> K >> X;
    vector<int> a;
    if(N > 2*X){
        cout << -1;
        return 0;
    }
    else if(X >= N){
        a.push_back(1);
        a.push_back(1+X);
        a.push_back(1+2*X);
        for(int i = 3; i < N; i++){
            a.push_back(a[i-1] - 1);
        }
    }
    else{
        a.push_back(1);
        a.push_back(1+X);
        for(int i = 2; i < X+1; i++){
             a.push_back(a[i-1] + 1);
        }
        int prom = a[1];
        for(int i = 0; i < N-X-1; i++){
            a.push_back(prom - 1);
            prom--;
        }
    }
    for(int i = 0; i < N; i++){
        cout << a[i] << " ";
    }
    return 0;
}